package com.fp.frontend.controller.bpm.lov;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.primefaces.context.RequestContext;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.enums.EnumLovOption;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.trans.TgeneTransaction;

/**
 * Clase controladora del bean TgeneTransactionLog.
 *
 * @author WPA
 * @version 2.1
 */
@ManagedBean
@ViewScoped
public class TransactionBpmELovController extends AbstractController<TgeneTransaction> {

    private static final long serialVersionUID = 1L;

    public TransactionBpmELovController() throws Exception {
        super(TgeneTransaction.class);
    }

    /**
     * Atributo para almacenar la respuesta del quieryalias
     */
    private List<Map<String, Object>> lTransactionLog;

    /**
     * Atributo para almacenar un arreglo de objetos
     */
    private Object objeto;

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 15; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "TGENETRANSACTION";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {

            Request request = this.callerhelper.getRequest();
            DtoQuery dto = super.getDtoQuery(true);

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.
            request.setQueryTables(mtables);

            request.put("querytype", "P");
            request.put("queryalias", "ENDEDFLOW");

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lTransactionLog = new ArrayList<Map<String, Object>>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lTransactionLog = (List<Map<String, Object>>) resp.get(this.beanalias);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    public void setTransaction() {
        // se utiliza en la pagina del lov.
        RequestContext.getCurrentInstance().closeDialog(this.objeto);
    }

    public void setTransaction(TgeneTransaction tgeneTransaction) {
        // se utiliza en la pagina del lov.
        RequestContext.getCurrentInstance().closeDialog(tgeneTransaction);
    }

    public void setTransaction(Map<String, Object> transactionLog) {
        RequestContext.getCurrentInstance().closeDialog(transactionLog);
    }

    public static void openLov(Map<String, List<String>> params) {
        Map<String, Object> options = new HashMap<String, Object>();
        options.put("modal", true);
        options.put(EnumLovOption.HEIGHT.getLabel(), 450);
        options.put(EnumLovOption.WIDTH.getLabel(), 700);
        options.put(EnumLovOption.RESIZABLE.getLabel(), false);

        RequestContext.getCurrentInstance().openDialog("/pages/bpm/lov/transactionbpmeLov.xhtml", options, params);
    }

    /**
     * Entrega la data del QueryAlias
     *
     * @return lTransactionLog Data del QueryAlias
     */
    public List<Map<String, Object>> getlTransactionLog() {
        return lTransactionLog;
    }

    /**
     * Fija la data del QueryAlias
     *
     * @param lTransactionLog Data del QueryAlias
     */
    public void setlTransactionLog(List<Map<String, Object>> lTransactionLog) {
        this.lTransactionLog = lTransactionLog;
    }

    /**
     * Entrega un arreglo de objetos
     *
     * @return objeto Arreglo de objetos
     */
    public Object getObjeto() {
        return objeto;
    }

    /**
     * Fija un arreglo de objetos
     *
     * @param objeto Arreglo de objetos
     */
    public void setObjeto(Object objeto) {
        this.objeto = objeto;
    }

}
